<div class="alert alert-danger" role="alert" *ngIf="invalid">
  The given credentials already exist or is invalid.
</div>

<div class="card">
  <div class="card-header">
    Sign Up!
  </div>

  <div class="card-body">
    <form novalidate
          (ngSubmit)="onAuthorize()"
          [formGroup]="registerForm">

      <div class="form-group row mb-2">
        <label class="col-md-2 col-form-label"
               for="userNameId">Username</label>
        <div class="col-md-8">
          <input class="form-control"
                 id="userNameId"
                 type="text"
                 placeholder="Username (required)"
                 formControlName="username"
                 [ngClass]="{'is-invalid': (registerForm.get('username').touched ||
                                            registerForm.get('username').dirty) &&
                                            !registerForm.get('username').valid }"/>
          <span class="invalid-feedback">
            <span *ngIf="registerForm.get('username').errors?.required">
              Please enter your username.
            </span>
            <span *ngIf="registerForm.get('username').errors?.minlength">
              The username must be longer than 5 characters.
            </span>
          </span>
        </div>
      </div>

      <div class="form-group row mb-2">
        <label class="col-md-2 col-form-label"
               for="nameId">Name</label>
        <div class="col-md-8">
          <input class="form-control"
                 id="nameId"
                 type="text"
                 placeholder="Name (required)"
                 formControlName="name"
                 [ngClass]="{'is-invalid': (registerForm.get('name').touched ||
                                            registerForm.get('name').dirty) &&
                                            !registerForm.get('name').valid }"/>
          <span class="invalid-feedback">
            <span *ngIf="registerForm.get('name').errors?.required">
              Please enter your name.
            </span>
          </span>
        </div>
      </div>

      <div class="form-group row mb-2">
        <label class="col-md-2 col-form-label"
               for="email">Email</label>
        <div class="col-md-8">
          <input class="form-control"
                 id="email"
                 type="email"
                 placeholder="Email (required)"
                 formControlName="email"
                 [ngClass]="{'is-invalid': (registerForm.get('email').touched ||
                                            registerForm.get('email').dirty) &&
                                            !registerForm.get('email').valid }"/>
          <span class="invalid-feedback">
            <span *ngIf="registerForm.get('email').errors?.required">
              Please enter your email.
            </span>
          </span>
        </div>
      </div>

      <div class="form-group row mb-2">
        <label class="col-md-2 col-form-label"
               for="password">Password</label>
        <div class="col-md-8">
          <input class="form-control"
                 id="password"
                 type="password"
                 placeholder="Password (required)"
                 formControlName="password"
                 [ngClass]="{'is-invalid': (registerForm.get('password').touched ||
                                            registerForm.get('password').dirty) &&
                                            !registerForm.get('password').valid }"/>
          <span class="invalid-feedback">
            <span *ngIf="registerForm.get('password').errors?.required">
              Please enter your password.
            </span>
            <span *ngIf="registerForm.get('password').errors?.minlength">
              The password must be longer than 6 characters.
            </span>
          </span>
        </div>
      </div>

      <div class="form-group row mb-2">
        <div class="offset-md-2 col-md-4">
          <button class="btn btn-primary"
                  type="submit"
                  [title]="registerForm.valid ? 'Save your entered data' : 'Disabled until the form data is valid'"
                  [disabled]="!registerForm.valid">
            Sign up
          </button>
        </div>
      </div>
    </form>
  </div>
</div>
